#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
import traceback

class FatalExceptionHandler(object):
    """Gestisce le eccezioni che terminano il programma."""
    ui = None

    def __init__(self, ui):
        """Inizializza il gestore per l'interfaccia utente specificata."""
        self.ui = ui
        sys.excepthook = self.exceptionHook
    
    def exceptionHook(self, type, value, tb):
        """Metodo richiamato automaticamente per le eccezioni non gestite."""
        msg = "***SI E' VERIFICATO UN ERRORE IMPREVISTO***\n" +\
            "Per favore invia alla mailing list quanto\n" +\
            "riportato qui sotto:\n" +\
            "----------------------------------------------------------\n" +\
            "Eccezione: " + str(type) + "\n" +\
            "Valore: " + str(value) + "\n"
        for i in traceback.format_exception(type, value, tb):
            msg += i
        msg += "Argomenti dalla linea di comando: " + str(sys.argv) + "\n"+\
            "\nTrovi i dettagli per l'iscrizione e l'invio\n"+\
            "alla mailing list sul sito: http://www.moioli.net/sms"
        
        #Visualizza l'errore
        self.ui.showFatalException(msg)
        
        #Termina il programma
        sys.exit(4)
