#!/usr/bin/python
# -*- coding: utf-8 -*-

from moio.errors.SenderError import SenderError

class SiteConnectionError(SenderError):
    """Errore per indicare un problema con la connessione ad un sito."""
    
    message = None
    
    def __init__(self, site, message = None):
        """Costruttore standard."""
        SenderError.__init__(self, site)
        self.message = message
    
    def __str__(self):
        s = u"Il sito " + self.site
        if self.message is None:
            s += u" non risponde.\n"
        else:
            s += u" ha risposto con l'errore: "+ self.message + u"\n"
            s += (u"Per favore controlla che:\n" +
             u"1) Internet funzioni,\n" +
             u"2) il sito " + self.site + " sia raggiungibile,\n" +
             u"3) sia possibile inviare SMS da " + self.site + u".\n" +
             u"Se il problema persiste ed è possibile inviare SMS \n" +
             u"dal Web, controlla che non sia uscita una nuova \n" +
             u"versione sul sito ufficiale: www.moioli.net")
        return s
