#!/usr/bin/python2.4
# -*- coding: utf-8 -*-
# Originale di Andrea "Lazza" Lazzarotto, http://www.andrealazzarotto.com
# Modificato e aggiornato da Silvio Moioli

import re
from cStringIO import StringIO

import pycurl

from moio.plugins.Sender import Sender
from moio.ConnectionManager import ConnectionManager
from moio.errors.SiteCustomError import SiteCustomError
from moio.errors.SiteConnectionError import SiteConnectionError
from moio.errors.SiteAuthError import SiteAuthError
from moio.errors.SenderError import SenderError

class Freebee(Sender):
    """Permette di spedire SMS dal sito Freebee.it"""
   
    maxLength = 110
    """Lunghezza massima del messaggio singolo inviabile da questo sito."""
   
    requiresRegistration = True
    """Questo plugin richiede nome utente e password?"""
   
    def isAvailable(self):
        """Ritorna true se questo plugin è utilizzabile."""
        return True
       
    def sendOne(self, number, text, username = None, password = None):
        """Spedisce un SMS con soli caratteri ASCII e di lunghezza massima maxLength
        con le credenziali specificate, supponendo Internet raggiungibile.
        """
        try:
            if number[:3] == "+39":
                number = number[3:]
            elif number[0]=="+":
                raise SiteCustomError(self.__class__.__name__,
                u"Questo sito permette di inviare SMS solo verso cellulari italiani.")

            c = self.connectionManager.getCurl()
            c.setopt(pycurl.HTTPHEADER, ["User-Agent:"])

            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            
            getFields = {}
            getFields["user"] = username
            getFields["pwd"] = password
            
            url = "http://www.freebee.it/send_mobile_/login.asp?"+self.codingManager.urlEncode(getFields);

            c.setopt(pycurl.URL, url)
            c.perform()
            
            try:
                userCode = re.search("1\n([0-9]+)", saver.getvalue()).group(1)
            except AttributeError:
                raise SiteAuthError(self.__class__.__name__)

            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.URL, "http://www.freebee.it/send_mobile_/syncAbook.asp?user="+str(username)+"&code="+userCode+"&version=0");
            c.perform()
            
            try:
                destinationId = re.search("\n([0-9]+),[^,]*,"+number, saver.getvalue()).group(1)
            except AttributeError:
                raise SiteCustomError(self.__class__.__name__,
                    u"Puoi inviare messaggi soltanto ai numeri che sono sulla rubrica del sito.\n"+
                    "Per inviare un messaggio a questo numero connettiti a freebee.it e aggiungilo alla rubrica.")
            
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.POST, True)
            postFields = {}
            postFields["code"] = str(userCode)
            postFields["type"] = "s1"
            postFields["idDestination"] = destinationId
            postFields["message"] = str(text)
            postFields["invTest"] = "1"
            
            c.setopt(pycurl.POSTFIELDS,
                self.codingManager.urlEncode(postFields))

            c.setopt(pycurl.URL, "http://www.freebee.it/send_mobile_/sendSms.asp");
            c.perform()

            if (re.search("1\n.+", saver.getvalue()) is None):
                raise SenderError(self.__class__.__name__)
            
        except pycurl.error, e:
            errno, msg = e
            raise SiteConnectionError(self.__class__.__name__, self.codingManager.iso88591ToUnicode(msg))