#!/usr/bin/python2.4
# -*- coding: utf-8 -*-

import re
from cStringIO import StringIO

import pycurl

from moio.plugins.Sender import Sender
from moio.ConnectionManager import ConnectionManager
from moio.errors.SiteCustomError import SiteCustomError
from moio.errors.SiteConnectionError import SiteConnectionError
from moio.errors.SiteAuthError import SiteAuthError
from moio.errors.SenderError import SenderError

class Smshosting(Sender):
    """Permette di spedire SMS dal sito smshosting.it"""
    
    maxLength = 151
    """Lunghezza massima del messaggio singolo inviabile da questo sito."""

    requiresRegistration = False
    """Questo plugin richiede nome utente e password?"""
    
    def isAvailable(self):
        """Ritorna true se questo plugin è utilizzabile."""
        return True
    
    def sendOne(self, number, text, username = None, password = None):
        """Spedisce un SMS con soli caratteri ASCII e di lunghezza massima maxLength
        con le credenziali specificate, supponendo Internet raggiungibile.
        """
        try:
            c = self.connectionManager.getCurl()
            c.setopt(pycurl.CONNECTTIMEOUT, 0)
            c.setopt(pycurl.TIMEOUT, 300)
            
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.POST, True)
            postFields = {}
            postFields["TextMessage"] = text
            postFields["GsmCode"] = number[:3]
            postFields["PhoneNumber"] = number[3:]
            postFields["software"] = "moiosms"
            c.setopt(pycurl.POSTFIELDS,
                self.codingManager.urlEncode(postFields))
    
            #Invio
            c.setopt(pycurl.URL,
                "http://www.smshosting.it/smsMaster/spedizioneFree.do")
            c.perform()
            
            if (saver.getvalue()=="KO" or
                re.search("messaggio non è stato inviato per il superamento",
                saver.getvalue(), re.I)):
                raise SiteCustomError(self, u"Impossibile inviare il tuo sms da smshosting.it.\n"+
                                     u"Controlla di non aver superato i limiti di utilizzo ed\n"+
                                     u"in particolare, ricorda che è concesso un solo sms \n"+
                                     u"per ogni numero destinatario.\n")
            
        except pycurl.error, e:
            errno, msg = e
            raise SiteConnectionError(self.__class__.__name__, self.codingManager.iso88591ToUnicode(msg))
