# -*- coding: UTF-8 -*-
# generated by wxGlade 0.4.1 on Fri Feb 16 09:55:51 2007

import sys
import os
import exceptions
from cStringIO import StringIO

import wx
import wx.lib.newevent

from moio.plugins.uis.GraphicalUI import GraphicalUI
from moio.PreferenceManager import PreferenceManager
from moio.CodingManager import CodingManager
from moio.plugins.Sender import Sender
from moio.errors.NotFoundError import NotFoundError
from moio.plugins.uis.Icons import getOkBitmap, getErrorBitmap, getIcon
from moio.plugins.uis.IconPanel import IconPanel
from moio.plugins.uis.PasswordErrorDialog import PasswordErrorDialog
from moio.errors.SiteAuthError import SiteAuthError
from moio.errors.SiteConnectionError import SiteConnectionError
from moio.errors.SiteCustomError import SiteCustomError
from moio.errors.SenderError import SenderError
from moio.errors.ConnectionError import ConnectionError
from moio.errors.CaptchaError import CaptchaError
from moio.errors.PreferenceManagerError import PreferenceManagerError

# begin wxGlade: dependencies
# end wxGlade

class MainFrame(wx.Frame):
    
    ui = GraphicalUI.getInstance()
    """Riferimento al plugin UI relativo a questo frame."""
    
    pm = PreferenceManager.getInstance()
    """Riferimento al gestore delle preferenze."""
       
    masterKey = None
    """La chiave di crittazione del PreferenceManager o None se non è settata."""

    def __init__(self, *args, **kwds):
        # begin wxGlade: MainFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.panel_1 = wx.Panel(self, -1)
        self.panel_2 = wx.Panel(self.panel_1, -1)
        self.label_1 = wx.StaticText(self.panel_2, -1, "A:")
        self.destinationComboBox = wx.ComboBox(self.panel_2, -1, choices=self.pm.getContacts().keys(), style=wx.CB_DROPDOWN|wx.CB_SORT)
        self.panel_7 = wx.Panel(self.panel_2, -1)
        self.deleteButton = wx.Button(self.panel_7, -1, "Cancella")
        self.addButton = wx.Button(self.panel_7, -1, "Metti in rubrica")
        self.panel_4 = wx.Panel(self.panel_1, -1)
        #HACK: messageTextCtrl più grande in Windows
        self.messageTextCtrl = wx.TextCtrl(self.panel_4, -1, "\n\n\n\n", style=wx.TE_MULTILINE)
        self.panel_5 = wx.Panel(self.panel_1, -1)
        self.senderRadioBox = wx.RadioBox(self.panel_5, -1, "Scegli il sito per l'invio", choices=Sender.getPlugins().keys(), majorDimension=4, style=wx.RA_SPECIFY_COLS)
        self.panel_6 = wx.Panel(self.panel_1, -1)
        self.sendButton = wx.Button(self.panel_6, -1, "Invia!")
        self.panel_3 = wx.Panel(self.panel_1, -1)
        self.bitmap = IconPanel(self.panel_3, -1)
        self.messageLabel = wx.StaticText(self.panel_3, -1, "Non in rubrica")
        self.gauge = wx.Gauge(self.panel_3, -1, 10, style=wx.GA_HORIZONTAL)

        self.__set_properties()
        self.__do_layout()
        # end wxGlade
        
        #Icona della taskbar
        self.SetIcon(getIcon());
              
        #HACK: messageTextCtrl più grande in Windows
        self.messageTextCtrl.SetValue("Inserisci il tuo messaggio qui.")
        
        #HACK: ctrl+A seleziona tutto in Windows
        self.messageTextCtrl.Bind(wx.EVT_CHAR, self.charEventHandler)
       
        #Evento: il testo nella combobox cambia
        #PRIMA viene richiamato destinationComboBoxEventHandler e POI updateLabel
        self.destinationComboBox.Bind(wx.EVT_TEXT, self.destinationComboBoxEventHandler)
        self.Bind(wx.EVT_TEXT, self.updateLabel, self.destinationComboBox)

        #Eventi: pressione di bottoni, vedi sopra
        self.addButton.Bind(wx.EVT_BUTTON, self.addButtonEventHandler)
        self.Bind(wx.EVT_BUTTON, self.updateLabel, self.addButton)
        self.deleteButton.Bind(wx.EVT_BUTTON, self.deleteButtonEventHandler)
        self.Bind(wx.EVT_BUTTON, self.updateLabel, self.deleteButton)
        
        #Altri eventi che comportano aggiornamenti della barra di stato
        self.Bind(wx.EVT_TEXT, self.updateLabel, self.messageTextCtrl)
        self.Bind(wx.EVT_RADIOBOX, self.updateLabel, self.senderRadioBox)
        
        #Altri eventi con handler specifici
        self.Bind(wx.EVT_BUTTON, self.sendButtonEventHandler, self.sendButton)
        self.Bind(wx.EVT_CLOSE, self.closeEventHandler)

        #Per evitare di riscrivere codice di inizializzazione già presente
        #negli eventHandler, creo un evento ad hoc per l'inizializzazione
        InitEvent, EVT_INIT = wx.lib.newevent.NewEvent()
        self.Bind(EVT_INIT, self.destinationComboBoxEventHandler)
        self.Bind(EVT_INIT, self.updateLabel)
        wx.PostEvent(self, InitEvent())
        
        #Se specificato da linea di comando, inserisco i parametri
        if (len(sys.argv) - 1 == 2) and sys.argv[1]=="-gui":
            self.destinationComboBox.SetValue(sys.argv[2])
        else:
            #altrimenti gli ultimi settaggi usati
            if self.pm.isLastUsedAvailable("destination"):
                self.destinationComboBox.SetValue(self.pm.getLastUsed("destination"))
        if self.pm.isLastUsedAvailable("sender"):
            self.senderRadioBox.SetStringSelection(self.pm.getLastUsed("sender"))
               
    def __set_properties(self):
        # begin wxGlade: MainFrame.__set_properties
        self.SetTitle("MoioSMS " + self.pm.getVersion())
        self.destinationComboBox.SetFocus()
        self.deleteButton.Hide()
        self.bitmap.SetMinSize((1, 1))
        self.senderRadioBox.SetSelection(0)
        self.sendButton.SetDefault()
        # end wxGlade
        
        if self.pm.isEncryptionEnabled():
            keyValid = False
            while keyValid == False:
                pd = wx.PasswordEntryDialog(None,
                    "Inserisci la Master Password", "Master Password", "", style=wx.OK|wx.CENTRE)
                result = pd.ShowModal()
                if result == wx.ID_CANCEL:
                    sys.exit(0)
                self.masterKey = pd.GetValue()
                keyValid = self.pm.checkEncryptionKey(self.masterKey)

    def __do_layout(self):
        # begin wxGlade: MainFrame.__do_layout
        grid_sizer_1 = wx.FlexGridSizer(1, 1, 0, 0)
        grid_sizer_2 = wx.FlexGridSizer(5, 1, 5, 0)
        grid_sizer_7 = wx.FlexGridSizer(1, 1, 0, 0)
        grid_sizer_6 = wx.FlexGridSizer(1, 1, 0, 0)
        grid_sizer_5 = wx.FlexGridSizer(1, 1, 0, 0)
        grid_sizer_4 = wx.FlexGridSizer(1, 3, 0, 5)
        grid_sizer_3 = wx.FlexGridSizer(1, 4, 0, 5)
        grid_sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        grid_sizer_3.Add(self.label_1, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        grid_sizer_3.Add(self.destinationComboBox, 0, wx.EXPAND, 0)
        grid_sizer_8.Add(self.deleteButton, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        grid_sizer_8.Add(self.addButton, 2, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        self.panel_7.SetAutoLayout(True)
        self.panel_7.SetSizer(grid_sizer_8)
        grid_sizer_8.Fit(self.panel_7)
        grid_sizer_8.SetSizeHints(self.panel_7)
        grid_sizer_3.Add(self.panel_7, 1, wx.EXPAND, 0)
        self.panel_2.SetAutoLayout(True)
        self.panel_2.SetSizer(grid_sizer_3)
        grid_sizer_3.Fit(self.panel_2)
        grid_sizer_3.SetSizeHints(self.panel_2)
        grid_sizer_3.AddGrowableCol(1)
        self.bitmap.SetMinSize((32,32))
        grid_sizer_2.Add(self.panel_2, 1, wx.LEFT|wx.RIGHT|wx.TOP|wx.EXPAND, 5)
        grid_sizer_4.Add(self.bitmap, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        grid_sizer_4.Add(self.messageLabel, 0, wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 0)
        grid_sizer_4.Add(self.gauge, 0, wx.EXPAND, 0)
        self.panel_3.SetAutoLayout(True)
        self.panel_3.SetSizer(grid_sizer_4)
        grid_sizer_4.Fit(self.panel_3)
        grid_sizer_4.SetSizeHints(self.panel_3)
        grid_sizer_4.AddGrowableCol(1)
        grid_sizer_4.AddGrowableCol(2)
        grid_sizer_2.Add(self.panel_3, 1, wx.LEFT|wx.RIGHT|wx.EXPAND, 5)
        grid_sizer_5.Add(self.messageTextCtrl, 0, wx.EXPAND, 0)
        self.panel_4.SetAutoLayout(True)
        self.panel_4.SetSizer(grid_sizer_5)
        grid_sizer_5.Fit(self.panel_4)
        grid_sizer_5.SetSizeHints(self.panel_4)
        grid_sizer_5.AddGrowableRow(0)
        grid_sizer_5.AddGrowableCol(0)
        grid_sizer_2.Add(self.panel_4, 1, wx.LEFT|wx.RIGHT|wx.EXPAND, 5)
        grid_sizer_6.Add(self.senderRadioBox, 0, wx.EXPAND, 0)
        self.panel_5.SetAutoLayout(True)
        self.panel_5.SetSizer(grid_sizer_6)
        grid_sizer_6.Fit(self.panel_5)
        grid_sizer_6.SetSizeHints(self.panel_5)
        grid_sizer_6.AddGrowableCol(0)
        grid_sizer_2.Add(self.panel_5, 1, wx.LEFT|wx.RIGHT|wx.EXPAND, 5)
        grid_sizer_7.Add(self.sendButton, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 5)
        self.panel_6.SetAutoLayout(True)
        self.panel_6.SetSizer(grid_sizer_7)
        grid_sizer_7.Fit(self.panel_6)
        grid_sizer_7.SetSizeHints(self.panel_6)
        grid_sizer_7.AddGrowableCol(0)
        grid_sizer_2.Add(self.panel_6, 1, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 5)
        self.panel_1.SetAutoLayout(True)
        self.panel_1.SetSizer(grid_sizer_2)
        grid_sizer_2.Fit(self.panel_1)
        grid_sizer_2.SetSizeHints(self.panel_1)
        grid_sizer_2.AddGrowableRow(2)
        grid_sizer_2.AddGrowableCol(0)
        grid_sizer_1.Add(self.panel_1, 1, wx.EXPAND, 0)
        self.SetAutoLayout(True)
        self.SetSizer(grid_sizer_1)
        grid_sizer_1.Fit(self)
        grid_sizer_1.SetSizeHints(self)
        grid_sizer_1.AddGrowableRow(0)
        grid_sizer_1.AddGrowableCol(0)
        self.Layout()
        self.Centre()
        # end wxGlade
        
    def getComboBoxValue(self, event = None):
        """Ritorna il valore della combobox (risolve un'incompatibilità
        con Windows)"""
        if '__WXMSW__' not in wx.PlatformInfo:
            return self.destinationComboBox.GetValue()
        else:
            #Windows non ritorna sempre il valore visualizzato tramite il
            #metodo GetValue. In particolare, dalle wx si ottengono tre
            #stringhe, potenzialmente diverse:
            #sel: corretto se si usa il mouse
            #val: corretto se si usa la tastiera
            #evt: corretto? Sarebbe bello...
            sel = self.destinationComboBox.GetStringSelection()
            val = self.destinationComboBox.GetValue()
            evt = None
            try:
                evt = event.GetString()
            except AttributeError:
                pass

            result = ""
            if self.destinationComboBox.GetSelection() == -1:
                #Se non si usa la combobox con il mouse, tutto bene
                result =  val
            elif sel == val:
                #Anche se si usa il mouse potrebbe andare comunque tutto bene
                result = val
            elif evt is not None:
                #Oppure no. In tal caso ritorno il valore dell'evento...
                result = evt
            else:
                #...e se non c'è, tiro a indovinare non avendo di meglio
                #da fare
                result = sel
            return result

    def updateLabel(self, event):
        """Aggiorna la barra dei messaggi segnalando all'utente eventuali problemi.
        Se vengono rilevati problemi, disabilita il bottone Invia."""
        canSend = True
        message = ""
        
        #1- Segnalazioni di errore
        destString = self.getComboBoxValue(event)
        text = self.messageTextCtrl.GetValue()
        if destString == "":
            message = "Inserisci un destinatario"
            canSend = False
        elif self.isNumber(destString) == False and self.pm.isInContacts(destString)==False:
            message = "Non in rubrica"
            canSend = False
        elif self.isNumber(destString) and self.isValid(destString) == False:
            message = "Inserisci un numero di cellulare"
            canSend = False
        elif text == "":
            message = "Inserisci del testo nel messaggio"
            canSend = False
            
        #2- Segnalazioni secondarie (da mostrare se non ci sono
        #errori
        if canSend:
            if event.GetEventObject() == self.messageTextCtrl:
                #2.1- L'utente ha appena scritto un carattere del mesaggio
                sender = Sender.getPlugins()[self.senderRadioBox.GetStringSelection()]
                texts = sender.splitText(sender.replaceNonAscii(text))
                textCount = len(texts)
                lastTextCharCount = len(texts[-1])
                remainingCharCount = sender.maxLength - lastTextCharCount + 1 
                if textCount==1:
                    message = "Scritto un messaggio,"
                else:
                    message = "Scritti "+str(textCount)+" messaggi,"
                if remainingCharCount==1:
                    message += " manca un carattere al prossimo."
                else:
                    message += " mancano "+str(remainingCharCount)+" caratteri al prossimo."
            else:
                #2.2- L'utente ha appena scritto un carattere del destinatario
                if self.pm.isInContacts(destString):
                    message = "In rubrica con il numero "+self.pm.lookup(destString)
                elif self.isValid(destString):
                    message = "Puoi salvare questo numero in rubrica"
        
        #Aggiorno la grafica
        self.messageLabel.SetLabel(message)
        sizer = self.panel_3.GetSizer()
        sizer.Show(self.gauge, False)
        if canSend:
            self.bitmap.setImage(getOkBitmap())
        else:
            self.bitmap.setImage(getErrorBitmap())
        self.sendButton.Enable(canSend)
        sizer.Layout()
        event.Skip()
        
    def isValid(self, number):
        """Ritorna True se il numero è valido."""
        l = len(number)
        if self.isNumber(number):
            hasCountryCode = number[0]=="+"
            return ((hasCountryCode and (l==12 or l==13)) or 
                    (hasCountryCode == False and (l==9 or l==10)))
        else:
            return False
    
    def isNumber(self, string):
        """Ritorna True se la stringa inserita è un numero oppure
         un numero preceduto da +."""
        if len(string)==0:
            return False
        elif len(string)==1:
            return string.isdigit() or string=="+"
        else:
            return string.isdigit() or (string[0]=="+" and string[1:].isdigit())

    def destinationComboBoxEventHandler(self, event): # wxGlade: MainFrame.<event_handler>
        """Mostra o nasconde i bottoni per la rubrica."""
        destString = self.getComboBoxValue(event)
           
        showAddButton = False
        showDeleteButton = False
        
        #Se c'è un destinatario, 5 casi:
        if destString != "":
            if self.isValid(destString):
                if self.pm.isNumberInContacts(destString):
                    #1-E' un numero in rubrica. Sostituisco col nome, propongo di cancellarlo
                    destString = self.pm.lookupNumber(destString)
                    self.destinationComboBox.SetStringSelection(destString)
                    showDeleteButton = True
                else:
                    #2-E' un numero valido non in rubrica. Propongo di aggiungerlo
                    showAddButton = True
            elif self.pm.isInContacts(destString):
                #3- è un nome in rubrica, propongo di cancellarlo
                showDeleteButton = True
            elif self.isNumber(destString)==False:
                #4- è un nome non in rubrica, propongo di aggiungerlo
                showAddButton = True
            #5- E' un numero ma non è valido
        
        #Aggiorno la grafica
        sizer = self.panel_7.GetSizer()
        sizer.Show(self.addButton, showAddButton)
        sizer.Show(self.deleteButton, showDeleteButton)
        sizer.Layout()
        event.Skip()

    def deleteButtonEventHandler(self, event): # wxGlade: MainFrame.<event_handler>
        """Cancella un contatto dalla rubrica e aggiorna la visualizzazione."""
        destString = self.getComboBoxValue()
        self.pm.deleteContact(destString)
        self.destinationComboBox.Delete(self.destinationComboBox.FindString(destString))
        self.destinationComboBox.SetStringSelection("")
        self.destinationComboBoxEventHandler(event)
        self.updateLabel(event)
        event.Skip()

    def addButtonEventHandler(self, event): # wxGlade: MainFrame.<event_handler>
        """Aggiunge un contatto alla rubrica e aggiorna la visualizzazione."""
        text = self.getComboBoxValue()
        #Due casi:
        if self.isValid(text):
            #L'utente ha immesso un numero, chiedo il nome
            name = u"Inserisci il nome qui"
            cancelled = False
            retried = False
            valid = False
            while (not valid) and (not cancelled):
                message = u"A che nome inserire "+text+" in rubrica?"
                if retried:
                    message += u"\nDevi inserire un nome in lettere."
                md = wx.TextEntryDialog(None, message, u"Aggiungi in rubrica",
                    name, wx.OK|wx.CANCEL|wx.CENTRE)
                if md.ShowModal() == wx.ID_CANCEL:
                    cancelled = True
                else:
                    name = md.GetValue()
                    if self.isNumber(name):
                        retried = True
                    elif name == "":
                        retried = True
                    else:
                        valid = True
                        self.pm.addContact(name, text)
                        self.destinationComboBox.Append(name)
                        self.messageTextCtrl.SetFocus()
        else:
            #L'utente ha immesso un nome, chiedo il numero
            number = u"Inserisci il numero qui"
            cancelled = False
            retried = False
            valid = False
            while (not valid) and (not cancelled):
                message = u"Qual'è il numero di "+text+"?"
                if retried:
                    message += u" Sono ammessi solo numeri di cellulare validi."
                md = wx.TextEntryDialog(None, message, u"Aggiungi in rubrica",
                    number, wx.OK|wx.CANCEL|wx.CENTRE)
                if md.ShowModal() == wx.ID_CANCEL:
                    cancelled = True
                else:
                    number = md.GetValue()
                    if self.isValid(number) == False:
                        retried = True
                    else:
                        valid = True
                        self.pm.addContact(text, number)
                        self.destinationComboBox.Append(text)
                        self.messageTextCtrl.SetFocus()
 
        self.destinationComboBoxEventHandler(event)
        self.updateLabel(event)
        event.Skip()
                  
    def sendButtonEventHandler(self, event): # wxGlade: MainFrame.<event_handler>
        """Mostra la barra di avanzamento (gauge) e richiama il metodo sendMessage."""
        #Aggiorna la grafica
        sizer = self.panel_3.GetSizer()
        sizer.Show(self.bitmap, False)
        sizer.Show(self.messageLabel, False)
        sizer.Show(self.gauge, True)
        sizer.Layout()
        self.destinationComboBox.Disable()
        self.addButton.Disable()
        self.deleteButton.Disable()
        self.messageTextCtrl.Disable()
        self.sendButton.Disable()
        self.senderRadioBox.Disable()
        self.gauge.SetValue(5)
        self.SetCursor(wx.StockCursor(wx.CURSOR_WAIT))
        self.Refresh()
        self.Update()

        #Manda effettivamente il messaggio.
        #E' necessario eseguire in un altro thread per una incompatibilità
        #con wxGTK
        wx.CallAfter(self.sendMessage)
        
        event.Skip()
        
    def sendMessage(self):
        """Spedisce un messaggio e aggiorna la grafica."""
        senderName = self.senderRadioBox.GetStringSelection()
        sender = Sender.getPlugins()[senderName]
        done = False
        hadError = False
        while done == False:
            try:
                un = None
                pw = None
                if sender.requiresRegistration:
                    un = self.pm.getUserName(senderName, self.masterKey)
                    pw = self.pm.getPassword(senderName, self.masterKey)
                dn = self.getComboBoxValue()
                if self.isValid(dn)==False:
                    dn = self.pm.lookup(
                        CodingManager.getInstance().quoteUnicode(dn))
                        
                if self.pm.isProxyEnabled():
                    os.environ["http_proxy"] = self.pm.getProxy()
                else:
                    if "http_proxy" in os.environ:
                        del os.environ["http_proxy"]
                
                sender.send(dn,
                    self.messageTextCtrl.GetValue(), un, pw)
                
                self.messageLabel.SetLabel("SMS INVIATO!")
                self.bitmap.setImage(getOkBitmap())
                done = True
            except PreferenceManagerError:
                md = PasswordErrorDialog(None, -1, "", style=wx.ICON_ERROR|wx.CENTRE)
                md.setMessage("Immetti un nome utente e una password " + \
                    "validi per il sito " + senderName)
                if md.ShowModal() == wx.ID_CANCEL:
                    done = True
                    hadError = True
                else:
                    self.pm.addAccount(md.getUserName(),
                       md.getPassword(), senderName, self.masterKey)
            except SiteAuthError:
                username = self.pm.getUserName(senderName, self.masterKey)
                password = self.pm.getPassword(senderName, self.masterKey)
                md = PasswordErrorDialog(None, -1, "", style=wx.ICON_ERROR|wx.CENTRE)
                md.setMessage("Nome utente e/o password non validi, " + 
                    "reimmetterli (sito "+senderName+")")
                md.setUserName(username)
                md.setPassword(password)
                if md.ShowModal() == wx.ID_CANCEL:
                    done = True
                    hadError = True
                else:
                    self.pm.addAccount(md.getUserName(),
                        md.getPassword(), senderName, self.masterKey)
            except ConnectionError:
                proxy = ""
                if self.pm.isProxyEnabled():
                    proxy = self.pm.getProxy()
                md = wx.TextEntryDialog(None,
                    "Internet funziona? Se usi un proxy immetti " + \
                    "l'indirizzo qui.\n Formato: http://nomeutente:password@indirizzo:porta",
                    "Errore di connessione", proxy,
                    style=wx.OK|wx.CANCEL|wx.CENTRE|wx.ICON_QUESTION)
                if md.ShowModal() == wx.ID_CANCEL:
                    done = True
                    hadError = True
                else:
                    proxy = md.GetValue()
                    if proxy != "":
                        self.pm.setProxy(proxy)
                    else:
                        self.pm.unsetProxy()
            except (SiteConnectionError, SiteCustomError, SenderError, CaptchaError), e:
                wx.MessageDialog(None, e.__str__(), "Errore",
                    wx.OK|wx.ICON_ERROR|wx.CENTRE).ShowModal()
                done = True     
                hadError = True
        
        #Riaggiorno la grafica
        if hadError:
            self.bitmap.setImage(getErrorBitmap())
            self.messageLabel.SetLabel(u"L'ultimo SMS non è stato inviato a causa di un errore.")

        sizer = self.panel_3.GetSizer()
        sizer.Show(self.bitmap, True)
        sizer.Show(self.messageLabel, True)
        sizer.Show(self.gauge, False)
        sizer.Layout()
        self.destinationComboBox.Enable()
        self.addButton.Enable()
        self.deleteButton.Enable()
        self.messageTextCtrl.Enable()
        self.sendButton.Enable()
        self.senderRadioBox.Enable()
        self.SetCursor(wx.NullCursor)
        self.Update()
        
        #Pronti per un altro messaggio
        self.messageTextCtrl.SetFocus()
        
    def closeEventHandler(self, event):
        """Salva il file di configurazione e termina il programma."""
        senderName = self.senderRadioBox.GetStringSelection()
        self.pm.setLastUsed("sender", senderName)
        self.pm.setLastUsed("destination", self.getComboBoxValue())
        
        if self.pm.isEncryptionSpecified() == False:
            result = wx.MessageDialog(None,
                u"MoioSMS sta per salvare i tuoi dati su disco.\n" +
                u"E' possibile salvare i tuoi dati di accesso ai siti in forma crittata (protetta), rendendo " +
                u"più difficile a terzi il loro utilizzo non autorizzato.\n" +
                u"Salvare i dati in forma crittata, però, rende necessario l'inserimento di una Master Password\n"
                u"ad ogni uso di MoioSMS.\n" +
                u"Vuoi salvare salvare in forma crittata tramite Master Password (non sarà possibile cambiare questa scelta)?\n",
                "Vuoi crittare i tuoi dati sensibili?", wx.YES|wx.NO|wx.ICON_QUESTION|wx.NO_DEFAULT).ShowModal()
            if result==wx.ID_YES:
                pd = wx.PasswordEntryDialog(None,
                        u"Inserisci la Master Password (ti verrà richiesta ad ogni uso di MoioSMS)",
                        "Master Password", "",
                        style=wx.OK|wx.CENTRE)
                pd.ShowModal()
                self.pm.enableEncryption(pd.GetValue())
            else:
                self.pm.disableEncryption()
        try:
            self.pm.writeConfigFile()
        except exceptions.IOError:
            wx.MessageBox(u"MoioSMS non può salvare i tuoi dati su disco. \n" +
                u"Controlla di poter scrivere sul file:\n" + self.pm.getConfigFileName() + "\n" +
                u"MoioSMS terminerà ora e nessun dato è stato salvato.",
                "Errore di salvataggio", wx.OK)
        sys.exit(0)

    # HACK: ctrl+A seleziona tutto in Windows
    def charEventHandler(self, event):
        command = event.CmdDown()
        keyCode = event.GetKeyCode()
        if command and (keyCode == ord('a') or keyCode == ord('A')):
            self.messageTextCtrl.SelectAll()
        else:
            event.Skip()
